#include <FK/FK.h>

// [VĐpNXg錾
#include "MotionCharactor.h"

int main(int argc, char *argv[])
{
	Fl_Window		main_win(512, 512, "FKP Motion Play Sample");
	fk_Light		light;
	fk_Model		camera, lightModel;
	fk_Scene		scene;
	fk_Window		fk_win(0, 0, 512, 512);

	// [VĐpNX̕ϐp
	CMotionCharactor	chara;

	// [Vp̕ϐ(gpȂ̂ŕK{ł͂Ȃ)
	int motionID = -1;

	// EBhE̍쐬
	main_win.end();
	// Fpbg̏
	fk_InitMaterial();

	// J̈ʒuƕݒ
	camera.glMoveTo(0.0, 30.0, 100.0);
	camera.glFocus(0.0, 30.0, 0.0);

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// fBXvCXgɃfƎ_ݒ
	scene.entryModel(&lightModel);
	scene.entryCamera(&camera);
	scene.setBGColor(1.0, 1.0, 1.0);

	// EBhEɃfBXvCXgݒ
	fk_win.setScene(&scene);

	// EBhEۂɕ`
	main_win.show();

	// ^ZR̃f[^ǂݍ
	if(!chara.loadObjectData("girl/girl.mqo")) fl_alert("Object Read Error.");
	// ZbgAbvf[^ǂݍ
	if(!chara.loadJointData("girl/girl_setup.fkc")) fl_alert("Joint Read Error.");
	// [Vf[^ǂݍ݂ǂݍ
	if(!chara.loadMotionData("girl/walk.fkm")) fl_alert("Motion Read Error.");
	if(!chara.loadMotionData("girl/punch2.fkm")) fl_alert("Motion Read Error.");
	if(!chara.loadMotionData("girl/kick2.fkm")) fl_alert("Motion Read Error.");

	// V[ւ̃Gg[(fk_Scene ̕ϐ & ēn)
	chara.entryScene(&scene);

	while(true){
		// [v̂܂菈
		if(main_win.visible() == 0){
			if(Fl::wait() == 0){
				break;
			}else{
				continue;
			}
		}
		if(fk_win.drawWindow() == 0) break;
		if(Fl::check() == 0) break;
		if(fk_win.winOpenStatus() == false) continue;

		// L[ɂčĐĂ郂[V̏Ԃω
		if(fk_win.getKeyStatus('1')) {
			motionID = 0;
		} else if(fk_win.getKeyStatus('2')) {
			motionID = 1;
		} else if(fk_win.getKeyStatus('3')) {
			motionID = 2;
		} else if(fk_win.getKeyStatus('0')) {
			motionID = -1;
		}

		// [V ID ɂāAĐ郂[V̎ނ𕪊򂷂

		// [v1񂲂Ƃ playMotion(Đԍ) ĂԂ1t[[Vi
		// Đԍ loadMotionData() œǂݍ񂾏(0X^[g)
		if(motionID == 0) {
			// ƌĂёƌJԂĐ
			chara.playMotion(0);
		} else if(motionID == 1 || motionID == 2) {
			// 1񂫂̍ĐŎ~߂ꍇ́AIođΏ
			if(chara.isMotionFinished(motionID) == true) {
				// [VIĂꍇ͉Ȃ悤ɂA
				// ̃[V֌q肷΂悢

				// ̗Ⴞƍŏ̃t[߂A
				// ID-1ɂčĐ͎~߂悤ɂĂ
				// x2΍Đ
				chara.setNowFrame(motionID, 0);
				motionID = -1;
			} else {
				chara.playMotion(motionID);
			}
		}

		// [VĐ̃LN^[𓮂ɂ getBaseModel()-> ɑ΂
		// fk_Model ̖߂g
		if(fk_win.getSpecialKeyStatus(FK_UP, false)) {
			chara.getBaseModel()->glTranslate(0.0, 0.5, 0.0);
		}
		if(fk_win.getSpecialKeyStatus(FK_DOWN, false)) {
			chara.getBaseModel()->glTranslate(0.0, -0.5, 0.0);
		}

	}

	return 0;
}
